#include <iostream>

using namespace std;

float rate;
float tax;

float total=0;
float normalh=0;
float overh=0;





void RapidPunchMenu(){
	float inh,inm,outh,outm;
	float in_punch,out_punch;
	float temp=0;
	for(;;){
		cout << endl << "type -1 for punch in hour to exit punch mode";
		cout << endl << "punch in hour: ";
		cin >> inh;
		if(inh==-1){
			return;
		}
		cout << endl << "punch in min: ";
		cin >> inm;
		in_punch=inh+(inm/60);
		cout << endl << "punch out hour: ";
		cin >> outh;
		cout << endl << "punch out min: ";
		cin >> outm;
		out_punch=outh+(outm/60);
		if(out_punch<in_punch){ //if out punch is after midnight
			temp=24-in_punch+out_punch;
		}else{
			temp=out_punch-in_punch;
		}
		total=total+temp;
		if(total>40){
			normalh=40;
			overh=total-40;
		}else{
			normalh=total;
			overh=0;
		}
		cout << endl;

	}

}

void CalcMenu(){
	cout << endl;
	cout << "normal hours: " << normalh << endl;
	cout << "overtime hours: " << overh << endl;
	cout << "normal pay: " << normalh*rate << endl;
	cout << "overtime pay: " << overh*(rate*1.5) << endl;
	cout << "total hour pay: " << normalh*rate+overh*(rate*1.5) << endl;
	cout << "actual pay: " << (normalh*rate+overh*(rate*1.5))*(1-(tax/100)) << endl;
	cout <<endl;
}

void TaxMenu(){
	cout << endl << "(approximate) tax %: ";
	cin >> tax;

}

void RateMenu(){
	cout << "Rate of pay: ";
	cin >> rate;
}

void HelpMenu(){
	cout << "Punch Calculator, v0.1" << endl;
	cout << "by Earlz <http://earlz.biz.tm> (c)2008" << endl;
	cout << "p -- rapid punch insert" << endl;
	cout << "c -- calculate hours and pay" << endl;
	cout << "q -- exit this program" << endl;
	cout << "? -- access this menu" << endl;
	cout << "h -- access this menu" << endl;
	cout << "ar -- adjust pay rate value" << endl;
	cout << "at -- adjust tax rate value" << endl;
	cout << "r --resets hour totals" << endl;
}

void ZeroHours(){
	total=0;
	normalh=0;
	overh=0;
}

int main(){
	cout << "-----------------------------" << endl;
	cout << "-------Punch Calculator------" << endl;
	cout << "-------by Earlz, v0.1  ------" << endl;
	cout << "-----------------------------" << endl;

	cout << endl << endl;

	//console system
	string cmd;
	bool used=0;
	RateMenu();
	TaxMenu();

	cout << "type h or ? for help" << endl;
	for(;;){
		used=0;

		cout << "> ";
		cin >> cmd;
		if((cmd=="h") || (cmd=="?")){
			HelpMenu();
			used=1;
		}
		if(cmd=="q"){
			return 0;
		}
		if(cmd=="p"){
			RapidPunchMenu();
			used=1;
		}
		if(cmd=="c"){
			CalcMenu();
			used=1;
		}
		if(cmd=="z"){
			ZeroHours();
			used=1;
		}
		if(cmd=="ar"){
			RateMenu();
			used=1;
		}
		if(cmd=="at"){
			TaxMenu();
			used=1;
		}

	}

    return 0;
}







